#ifndef __PLATFORM_H
#define __PLATFORM_H

#include <stdint.h>
#include "stm32f0xx_hal.h"

#define TIM_ARR_SW 479		// Auto-reload value : 100kHz overflow (Per phase freq)
#define TIM_ARR_PHSYNC 159	// Auto-reload value : 300kHz overflow (Phase synchronizer freq)
#define TIM_ARR_CON 959		// Auto-reload value : 50kHz overflow
// Tdtg = Tdts = 1/fTIM16 = 1/48MHz
// Dead-time = 10/48MHz = 0.21uS
#define TIM_DEADTIME 10
__STATIC_INLINE void TIM_PWM_ENABLE() {
	TIM1->BDTR |= TIM_BDTR_MOE;
	TIM16->BDTR |= TIM_BDTR_MOE;
	TIM17->BDTR |= TIM_BDTR_MOE;
}

__STATIC_INLINE void TIM_PWM_DISABLE() {
	TIM1->BDTR &=~ TIM_BDTR_MOE;
	TIM16->BDTR &=~ TIM_BDTR_MOE;
	TIM17->BDTR &=~ TIM_BDTR_MOE;
}

__STATIC_INLINE void TIM_PWM_SETVAL(uint32_t val) {
	TIM1->CCR2 = val;
	TIM16->CCR1 = val;
	TIM17->CCR1 = val;
}

void hw_init(void);

#endif
